// rewritten by Zheng Gengbin and Shi Lixia
// translate:
// read/write/print
// io control statements
//
#ifdef HAVE_CONFIG_H
#include "config.h"
#endif

#if STDC_HEADERS
#include <stdlib.h>
#include <string.h>
#else
#include <strings.h>
extern "C" void exit(...);
#endif

#include <stdio.h>

#include "compilerApi.h"
#include "strategy.h"

#include "anls_att.h"
#define  MAXNUM 100

extern int getreflevel(SgSymbol * index, SgExpression * expr);
extern SgExpression * getlinerexp(int i, SgSymbol * symb, SgExpression * expr);

//iooc.cc  add by  slx  98/3/4
extern void trans_iooc(SgInputOutputStmt *,SgStatement *,int *);
extern int isIooc(SgInputOutputStmt *);
//ioC.cc   add by  slx  98/4/2
extern int is_format_io(SgInputOutputStmt *print);
extern void change_datatransfer2C(SgInputOutputStmt *, SgExpression *);

//extern "C" int strcasecmp(...);
//extern "C" int strncasecmp(...);

#define COMPACT 1

Impdo_header_def::Impdo_header_def()
{
  number=0;
  for (int i=0; i<MAX_INDEX_DIM; i++) 
    for (int j=0; j<3; j++)
      index[i].indextriple[j]=NULL;
}

int Impdo_header_def::numberOfIndex()
{
  return number;
}

void Impdo_header_def::setIndexSymbol(SgSymbol * s)
{
  number++;
  index[number-1].indexvar=s;
}

SgSymbol * Impdo_header_def::indexSymbol(int i)
{
  return index[i].indexvar;
}

void Impdo_header_def::setIndexTriplet(int i, SgExpression * triplet)
{
  index[number-1].indextriple[i]=triplet;
}

SgExpression * Impdo_header_def::getIndexTriplet(int i, int j)
{
  return index[i].indextriple[j];
}

//------------------------;

io_reference::io_reference ()
{
  for (int i=0; i<MAX_ALIGN_DIM; i++) 
    for (int j=0; j<MAX_INDEX_DIM; j++)
      index_level[i][j]=0;
  ihdef = NULL;
  func = NULL;
  sameAs = 0;
}

void io_reference::setExpression(SgExpression * e)
{
  expr=e;
  symb=e->symbol();
}

SgExpression * io_reference::expression()
{
  return expr;
}

void io_reference::setFunction(SgExpression * e)
{
  func=e;
}

SgExpression * io_reference::getFunction()
{
  return func;
}

SgSymbol * io_reference::symbol()
{
  return symb;
}

void io_reference::setIndex(int arraydim, int indexdim,int IL)
{
  index_level[arraydim][indexdim]=IL;
}

int io_reference::getIndex(int arraydim, int indexdim)
{
  return index_level[arraydim][indexdim];
}

void io_reference::setStride(int arraydim, int indexdim, SgExpression * expr)
{
  stride[arraydim][indexdim]=expr;
}

SgExpression * io_reference::getStride(int arraydim, int indexdim)
{
  return stride[arraydim][indexdim];
}

void io_reference::setOffset(int arraydim, int indexdim, SgExpression * expr)
{
  offset[arraydim][indexdim]=expr;
}

SgExpression * io_reference::getOffset(int arraydim, int indexdim)
{
  return offset[arraydim][indexdim];
}

int io_reference::hasIndexOnDim(int dim)
{
  for (int i=0; i<MAX_INDEX_DIM; i++) {
    if (index_level[dim][i]!=0)
      return 1;
  }
  return 0;
}

int io_reference::indexSequenceOnDim(int dim)
{
  for (int i=0; i<MAX_INDEX_DIM; i++)
    if (index_level[dim][i]!=0)
      return i;
  // return the first one;
//  return (printf("indexSequenceOnDim:This is a scalar dim.\n"));
  return -1;
}

int io_reference::evaluatable()
{
  for (int i=0; i<MAX_ALIGN_DIM; i++) {
    for (int j=0; j<MAX_INDEX_DIM; j++) {
      if (stride[i][j]!=NULL)
	if(!stride[i][j]->isInteger()) {
	  return(0);
	};

      if (offset[i][j]!=NULL)
	if(!stride[i][j]->isInteger()) {
	  return(0);
	}
	  
    }
  }
  return (1);
}

int io_reference::checkRegular()
{
  switch (expr->variant()) {
  case VAR_REF: 
    return (1);
    break;
  case ARRAY_REF:
    {
      SgArrayRefExp * array = (SgArrayRefExp *) expr;

      for (int i=0; i<array->numberOfSubscripts(); i++) {
	int indexcounter = 0;
	for (int j=0; j<MAX_INDEX_DIM; j++)
	  if (index_level[i][j]!=0)
	    if (index_level[i][j]!=1)
	      return 0;
	    else
	      indexcounter++;
	if (indexcounter>1)
	  return 0;
      }

      return 1;
      break;
    };
  default:
    if (!silentFlag)
    printf("Not touched forall reference!\n");
  }
  return 0;
}

void io_reference::show()
{

}

// reuse in next stmt;
int io_reference::reusable()
{
  return sameAs >= 10000?1:0;
}

// reuse in previous stmt;
int io_reference::useNo()
{
  int sameas = sameAs;
  if (sameas >= 10000) sameas =  sameas - 10000;
  return sameas > 0?1:0;
}

/*************************************************************************
		 analyse_datatransfer()
*************************************************************************/

void fill_impdo_header(Impdo_header_def * ihdef, SgExpression * exp)
{
  switch (exp->variant()) {

  case EXPR_LIST: {
    SgExprListExp * exprlist=(SgExprListExp *)exp;
    for (int i=0; i<exprlist->length(); i++) {
      fill_impdo_header(ihdef, exprlist->elem(i));
    };
    break;
  };

  case IMPLIED_DO: {
    SgImpliedDoExp * impdo = (SgImpliedDoExp *) exp; 

	// zheng.gb 1997/9/29  add left branch first !
    SgExpression * list = impdo->list();    
    fill_impdo_header(ihdef, list);

    ihdef->setIndexSymbol(impdo->index());

    for (int i=0; i<impdo->numberOfTriplet(); i++) {
      ihdef->setIndexTriplet(i, impdo->triplet(i));
    }
    break;
  };

  default:
    break;
  }
}

SgExpression *functionExp;

void add_impdo_reference(SgStatement * s, SgExpression *exp, Impdo_header_def *ihdef=NULL)
{
  switch (exp->variant()) {
  case IMPLIED_DO: {
    SgImpliedDoExp * impdo = (SgImpliedDoExp *) exp; 
    add_impdo_reference(s, impdo->list(), ihdef);
    break;
  }
  
  case EXPR_LIST: {
    SgExprListExp * exprlist=(SgExprListExp *)exp;
    for (int i=0; i<exprlist->length(); i++) {
         add_impdo_reference(s, exprlist->elem(i), ihdef);
    }
    break;
  }

  case ADD_OP:
  case MINUS_OP:
  case MULT_OP:
  case DIV_OP:
  case MOD_OP: {
    add_impdo_reference(s, exp->operand(1), ihdef);
    add_impdo_reference(s, exp->operand(2), ihdef);
    break;
  }

  case ARRAY_REF: {
    io_reference * iref = new io_reference();
    iref->setExpression(exp);
    iref->setFunction(functionExp);
    iref->ihdef = ihdef;
    s->addAttribute(Io_Ref,(void *)iref, sizeof(io_reference));
    break;
  }

  case VAR_REF: {
    s->addAttribute(IoScalar_Ref,exp, sizeof(exp));
    break;
  }

  case INT_VAL:
  case FLOAT_VAL:
  case DOUBLE_VAL:
  case BOOL_VAL:
  case STRING_VAL: {
    // do nothing;
    break;
  }
  
  case FUNC_CALL:  {
    break;
  }

  case INTRIN_FUNC_CALL: {
    SgFunctionRefExp * funExp = (SgFunctionRefExp *) exp;
      	  // we use special method to deal with the dummy of elementary intrinsic function.
    if (ioMode == IO_C && functionExp == NULL) {
	functionExp = funExp;
    }
    if (((SgFunctionSymb*)funExp->symbol())->is_elementary_function()==1)
    {
  	  // look the actual arg as an array
      	for (int i=0; i<funExp->numberOfArgs(); i++) 
      	  	add_impdo_reference(s, funExp->arg(i), ihdef);
    }
    if (functionExp == funExp) {
	functionExp = NULL;
    }
    break;
  }

  default:
    if (!silentFlag)
    printf("In add_impdo_reference, unexpected expression on line %d, id: %d, variant: %d\n",s->lineNumber(), exp->id(),exp->variant() );
    break;

  }
}
  
void get_impdo_reference(SgInputOutputStmt *print, SgExpression *item)
{
	switch  (item->variant() )
        {
	case IMPLIED_DO: {
 		  // get Impdo_header_def
		Impdo_header_def * ihdef = new Impdo_header_def();
		fill_impdo_header(ihdef, item);
		print->addAttribute(IHDER_Def,(void *) ihdef, sizeof(Impdo_header_def));
		  // get io_reference
         	add_impdo_reference(print, item, ihdef);
		break;
	     }
	case ARRAY_REF: {
         	add_impdo_reference(print, item);
		break;
	     }
  	case INTRIN_FUNC_CALL: {
      		SgFunctionRefExp * funExp = (SgFunctionRefExp *) item;
      		// we use special method to deal with the dummy of elementary intrinsic function.
      		if (((SgFunctionSymb*)funExp->symbol())->is_elementary_function()==1)
      		{
	   		// look the actual arg as an array
      			for (int i=0; i<funExp->numberOfArgs(); i++) 
      	   		       get_impdo_reference(print, funExp->arg(i));
      		}
      		break;
  	     }
	case FUNC_CALL: {
		break;
	     }
	default:	{		// zheng.gb 1998/2/15
         	add_impdo_reference(print, item);
		break;
	     }
	}
}

void get_impdo_reference(SgInputOutputStmt * print)
{
    if ( print->itemList() == NULL) return;
    SgExprListExp * exprlist=(SgExprListExp *)print->itemList();

    for (int i=0; i<exprlist->length(); i++) {
	SgExpression *item = exprlist->elem(i);
	get_impdo_reference(print, item);
    }
}


// can only deal with regular case
void index_impdo_reference(SgInputOutputStmt * print)
{
  for (int numi = 0; numi < print->numberOfAttributes(Io_Ref) ; numi++ )
  {
    io_reference * iref = (io_reference *)print->attributeValue(numi, Io_Ref);
    SgArrayRefExp * arrayexp = (SgArrayRefExp *) iref->expression();
    Impdo_header_def *ihdef = iref->ihdef;
    if (ihdef == NULL) continue;

    for (int i=0; i<ihdef->numberOfIndex(); i++) {

	SgSymbol * index = ihdef->indexSymbol(i);

	for (int k=0; k<arrayexp->numberOfSubscripts();k++) {
	  int indexlevel=getreflevel(index, arrayexp->subscript(k));
	  iref->setIndex(k, i, indexlevel);
	  
	  if (indexlevel==1) {
	    SgExpression * stride = getlinerexp(1, index, arrayexp->subscript(k));
	    SgExpression * offset = getlinerexp(0, index, arrayexp->subscript(k));

	    iref->setStride (k, i, stride);
	    iref->setOffset (k, i, offset);
	  }
	}  //end of for(k)
       }  // end of for(i)
  }
}

void analyse_previous_write(SgStatement *s);

void analyse_datatransfer(SgStatement * s)
{
  SgInputOutputStmt * print = (SgInputOutputStmt *)s;

  //printf ("%d, %d\n", print->specList()->id(), print->itemList()->id());

//  get_impdo_header(print);
  get_impdo_reference(print);
  index_impdo_reference(print);

  analyse_previous_write(print);
}

// -------------------------------

int same_io_reference(io_reference *iref1, io_reference *iref2)
{
   if (iref1->symbol() != iref2->symbol()) return 0;
   for ( int i=0; i<MAX_ALIGN_DIM; i++) 
   {
   	int index1 = iref1->indexSequenceOnDim(i);
   	int index2 = iref2->indexSequenceOnDim(i);
	if (index1 != index2) return 0;
	if (iref1->getStride(i, index1))
	   if (*iref1->getStride(i, index1) != *iref2->getStride(i, index2)) return 0;
	SgExpression *exp1 = iref1->getOffset(i, index1);
	SgExpression *exp2 = iref2->getOffset(i, index2);
	if (exp1 == NULL && exp2 == NULL) continue;
	if (exp1 == NULL || exp2 == NULL) return 0;
	if ( *exp1 != *exp2 ) return 0;
   }

   return 1;
}

int same_io_header(Impdo_header_def *ihdef1, Impdo_header_def *ihdef2)
{
   if (ihdef1->numberOfIndex() != ihdef2->numberOfIndex() ) return 0;
   for (int i=0 ; i< ihdef1->numberOfIndex(); i++)
   {
	SgExpression *exp1 = ihdef1->getIndexTriplet(i, 0);
	SgExpression *exp2 = ihdef2->getIndexTriplet(i, 0);
	if (exp1 == NULL || exp2 == NULL) return 0;
	exp1 = calculateExp(exp1);
	exp2 = calculateExp(exp2);
	if ( *exp1 != *exp2 ) return 0;

	exp1 = ihdef1->getIndexTriplet(i, 1);
	exp2 = ihdef2->getIndexTriplet(i, 1);
	if (exp1 == NULL || exp2 == NULL) return 0;
	exp1 = calculateExp(exp1);
	exp2 = calculateExp(exp2);
	if ( *exp1 != *exp2 ) return 0;

	exp1 = ihdef1->getIndexTriplet(i, 2);
	exp2 = ihdef2->getIndexTriplet(i, 2);
	if (exp1 == NULL && exp2 == NULL) continue;
	if (exp1 == NULL || exp2 == NULL) return 0;
	exp1 = calculateExp(exp1);
	exp2 = calculateExp(exp2);
	if ( *exp1 != *exp2 ) return 0;
   }
   return 1;
}

// try to find if the previous write use same array
// sameAs < 0 means it will be use next
// sameAs > 0 means use prevoius
void analyse_previous_write(SgStatement *s)
{
  if (s->variant() != WRITE_STAT) return;
  SgStatement *prev = s->previousInChildList();
  if (!prev || prev->variant() != WRITE_STAT) return;

  for (int i=0; i<s->numberOfAttributes(Io_Ref); i++) {

     // add by slx 98/3/8
     // in order to record dim_num in a io_reference
    io_reference *iref=(io_reference *)s->attributeValue(i,Io_Ref); 

    Impdo_header_def * ihdef = iref->ihdef;
    if (ihdef == NULL) continue;
    for (int j=0; j<prev->numberOfAttributes(Io_Ref); j++) {
    	io_reference *iref0=(io_reference *)prev->attributeValue(j,Io_Ref); 

	Impdo_header_def * ihdef0 = iref0->ihdef;
	if (ihdef0 == NULL) continue;
	if (!same_io_header(ihdef, ihdef0)) continue;
	if (!same_io_reference(iref, iref0)) continue;
	// ok, same as in previous one
if (!silentFlag)
printf("'%s' is same as prevoius write statement.\n", iref->symbol()->identifier());
	iref->sameAs = j+1;
	iref0->sameAs = 10000+iref0->sameAs;
    }
  };
}

/*************************************************************************
		 change_datatransfer()
*************************************************************************/

// create sdd
void create_section(SgInputOutputStmt * print, int counter)
{

  io_reference * iref= (io_reference *) ((print->getAttribute(counter, Io_Ref))->getAttributeData());
  Impdo_header_def *ihdef = iref->ihdef;

  SgArrayRefExp * array = (SgArrayRefExp *) iref->expression();  
  SgSymbol * arraysymb  = array->symbol();

   // use previous one
  if (iref->useNo() > 0) return;

  // pcrc_new_array_section
  {
    SgSymbol *dadsec = print->getSymbolInCurrentScope(mixstring, "sdd", NULL, counter);
    int dim=0;
    if (ihdef!=NULL) {
      for (int i=0; i<array->numberOfSubscripts(); i++)
	if (iref->hasIndexOnDim(i))
	  dim++;
    }
    SgSymbol * dad = print->getSymbolInCurrentScope(mixstring, "dad", arraysymb->identifier());
    SgStatement *assign = make_new_array_section(print, dadsec, dim , dad);
    print->insertStmtBefore(*assign, *print->controlParent());
  }

  int dimcounter =0;
  for (int i=0; i<array->numberOfSubscripts(); i++) {

    if (iref->hasIndexOnDim(i)) {
	// set_array_triplet()
      SgSymbol * dadsymb = print->getSymbolInCurrentScope(mixstring, "sdd", NULL, counter);
      dimcounter++;
 
      // we need to change the header, so all expression should be a copy;
      //ihdef = (Impdo_header_def *) print->attributeValue(0, IHDER_Def);
     
      SgExpression *startExp, *endExp ;

      int seq = iref->indexSequenceOnDim(i);
      startExp = NULL;
      if (ihdef->getIndexTriplet(seq, 0)!=NULL) {
	    SgExpression * triplet = ihdef->getIndexTriplet(seq, 0);

	    startExp=iref->getOffset(i, seq);

	    startExp=startExp+((*iref->getStride(i,seq)->copyPtr()) * (*triplet->copyPtr()));

	    startExp = calculateExp(startExp);
      }
      ASSERT(startExp);

      endExp=NULL;
      if (ihdef->getIndexTriplet(seq, 1)!=NULL) {
	    SgExpression * triplet = ihdef->getIndexTriplet(seq, 1);

	    endExp=iref->getOffset(i, seq);

	    endExp=endExp+((*iref->getStride(i, seq)->copyPtr())*(*triplet->copyPtr()));

	    endExp = calculateExp(endExp);
				    
      }
      ASSERT(endExp);

         //  if (ihdef->getIndexTriplet(iref->indexSequenceOnDim(i), 2)!=NULL) {
         //  we don't consider the stride in the header at the moment;
      SgExpression *strideExp=NULL;
      if(COMPACT) {
	    SgExpression *triplet=ihdef->getIndexTriplet(seq, 2);

	    if (triplet)
	    	strideExp = triplet->copyPtr();

	    if (iref->getStride(i, seq)!=NULL)
	      strideExp=strideExp*(*iref->getStride(i, seq));
       }
       else{
	    strideExp = new SgValueExp(1);

	    if (iref->getStride(i, seq)!=NULL)
	      strideExp=strideExp * (*iref->getStride(i, seq)->copyPtr());
       }
       strideExp = calculateExp(strideExp);

      SgSymbol * dad = print->getSymbolInCurrentScope(mixstring, "dad", arraysymb->identifier());	
      int dim = i+1;

      analyse_expression(print, startExp);
      analyse_expression(print, endExp);
      analyse_expression(print, strideExp);
      SgStatement *funcall = make_set_array_triplet(print,dadsymb,dimcounter,
                                    startExp,endExp,strideExp,dad,i+1);
      print->insertStmtBefore(*funcall, *print->controlParent());
    }
    else {	
	// pcrc_set_array_scalar
      SgSymbol * dadsymb = print->getSymbolInCurrentScope(mixstring, "sdd", NULL, counter);
      SgExpression * scalar = ((SgArrayRefExp *) iref->expression())->subscript(i)->copyPtr();
      SgSymbol * dad = print->getSymbolInCurrentScope(mixstring, "dad", arraysymb->identifier());
      int dim = i+1;
      SgStatement * funcall = make_set_array_scalar(print, dadsymb, scalar,
							dad,dim);
      print->insertStmtBefore(*funcall, *print->controlParent());
    };
  }

  // delete dad;
  {
	// pcrc_delete_array
    SgSymbol * dad=print->getSymbolInCurrentScope(mixstring, "sdd", NULL, counter);
    SgStatement * funcall = make_delete_array(print , dad);

    print->insertStmtAfter(*funcall, *print->controlParent());
  };

}

// create temp "tdd"
void create_array(SgInputOutputStmt * print, int counter)
{
  io_reference * iref= (io_reference *)print->attributeValue(counter, Io_Ref);
  Impdo_header_def *ihdef = iref->ihdef;
//  ASSERT(ihdef);

  SgArrayRefExp * array = (SgArrayRefExp *) iref->expression();  
  SgSymbol * arraysymb  = array->symbol();

  int storage = getArrayStorage(arraysymb);

   // use previous one
  int skip = 0;
  if (iref->reusable()) skip = 1;
  int useNo = iref->useNo();

  if (useNo > 0)
  {
     SgSymbol *tdd0 = print->getSymbolInCurrentScope(mixstring, "tdd", NULL, iref->useNo()-1);
     SgSymbol *tdd = print->getSymbolInCurrentScope(mixstring, "tdd", NULL, counter);
     SgAssignStmt *stmt = new SgAssignStmt(*new SgVarRefExp(tdd), *new SgVarRefExp(tdd0));
     print->insertStmtBefore(*stmt, *print->controlParent());
  }

  // pcrc_new_array_data
  if ( useNo == 0)
  {
    SgType * stype= arraysymb->type();

    SgSymbol *dad = print->getSymbolInCurrentScope(mixstring, "tdd", NULL, counter);
    int dim = 0;
    if (ihdef!=NULL) {
      for (int i=0; i<array->numberOfSubscripts(); i++)
	if (iref->hasIndexOnDim(i))
	  dim++;
    }
    SgSymbol * grp=print->getSymbolInCurrentScope(mixstring, "grp", "io");
    SgExpression *grpExp = new SgVarRefExp(grp);
    SgStatement *assign = make_new_array_data(print, dad, stype, storage, dim, grpExp);
    print->insertStmtBefore(*assign, *print->controlParent());
  }

  int numberOfSubscripts = array->numberOfSubscripts();
  int dimcounter = storage==COLUMN_MAJOR?0:(ihdef?ihdef->numberOfIndex()+1:0);
  int d, i;
  if ( useNo == 0)
  for (d=0; d<numberOfSubscripts; d++) {
	// set_array_collapse
    if (storage == COLUMN_MAJOR)
    	i = d;
    else 
	i = numberOfSubscripts - d -1;
    if (iref->hasIndexOnDim(i)) {
      if (storage == COLUMN_MAJOR) dimcounter++;
      else dimcounter--;

      SgSymbol * dad = print ->getSymbolInCurrentScope(mixstring, "tdd", NULL, counter);
      SgValueExp *zero = new SgValueExp(0);
      int indexcounter=iref->indexSequenceOnDim(i);
      ASSERT(ihdef);
      SgExpression *upper;
      SgExpression *startExp = ihdef->getIndexTriplet(indexcounter, 0)->copyPtr();
      SgExpression *endExp = ihdef->getIndexTriplet(indexcounter, 1)->copyPtr();
      SgExpression *strExp = ihdef->getIndexTriplet(indexcounter, 2);
      upper = &(*endExp - *startExp);
      if (COMPACT) {
	if (strExp)
      	   upper = &(*upper / *strExp->copyPtr());
      }
      analyse_expression(print, upper);

      SgStatement *func = make_set_array_collapse(print, dad, dimcounter, 
						zero, upper);
      print->insertStmtBefore(*func, *print->controlParent());
    }
  }

  // delete dad;
  if (!skip)
  {
    SgSymbol * dad=print->getSymbolInCurrentScope(mixstring, "tdd", NULL, counter);
    SgStatement *funcall = make_delete_array(print , dad);
    print->insertStmtAfter(*funcall, *print->controlParent());
  };
  
    // add by slx 98/3/10
    // if outofcore, pcrc_oc_init(pcrc_tdd,IN_CORE_SIZE,storage)
  if ( useNo == 0)
  {
      // optimize: if the array is one dimension refered, we donot do it in out-of-core mode.
   if((is_out_of_core(arraysymb)) && ihdef != NULL 
        && ihdef->numberOfIndex() > 1 )
     {
      SgSymbol * dad=print->getSymbolInCurrentScope(mixstring, "tdd", NULL, counter);
      SgStatement *funcall=make_oc_init(print,dad,IN_CORE_SIZE);
      print->insertStmtBefore(*funcall, *print->controlParent());
     }
  }  

  // allocate memory;
  SgSymbol * mHandle;
  SgStatement *alloc;
  if ( useNo == 0)
  {
    SgSymbol * base = print->getSymbolInCurrentScope(mixstring, "tbs", NULL, counter);
    SgSymbol * dadbase = print->getSymbolInCurrentScope(mixstring, "tdd", NULL, counter);

#ifdef MEM_ALLOC
    	mHandle = print->getSymbolInCurrentScope(mixstring, "mh", NULL, counter);
	alloc = make_stack_alloc(print,arraysymb->type(),base,dadbase,mHandle);
#else
	alloc = make_alloc(print,arraysymb->type(),base,dadbase);
#endif

    print->insertStmtBefore(*alloc, *print->controlParent());
  }

  // reset base;
  if ( useNo == 0)
  {
    SgSymbol * base = print->getSymbolInCurrentScope(mixstring, "tdd", NULL, counter);
    SgSymbol * basesym = print->getSymbolInCurrentScope(mixstring, "tbs", NULL,counter);

    SgStatement *funcall=make_reset_in_core_base(print,base,arraysymb->type(),basesym, new SgVarRefExp(mHandle));

    print->insertStmtBefore(*funcall, *print->controlParent());
  }

  // call real free;
  if (!skip)
  {
#ifdef MEM_ALLOC
    SgSymbol * base = print->getSymbolInCurrentScope(mixstring, "mh", NULL, counter);
#else
    SgSymbol * base = print->getSymbolInCurrentScope(mixstring, "tbs", NULL, counter);
#endif

    SgStatement * funcall = make_free(print,arraysymb->type(),base);
    
    print->insertStmtAfter(*funcall, *print->controlParent());
  }
  
}

void add_format_for_read(SgInputOutputStmt *print,SgExpression *kindexp)
{
   int kindval;
   if (kindexp->isInteger()) kindval=kindexp->valueInteger();
   else ASSERT(0);
   char *fmt = (char *)malloc(20);

   SgExpression *speclist=print->specList();
   SgExpression *expr;
   for(expr=speclist; expr; expr=expr->rhs())
   {
        SgExpression *keyParent=expr->lhs();
        SgKeywordValExp *keyword=isSgKeywordValExp(keyParent->lhs());
        if(keyword != NULL )
        { 
           if(strcasecmp(keyword->value(),"fmt")==0) break;
        }
   }
   if (expr) {
        SgExpression *keyParent=expr->lhs();
	SgExpression *keyword = keyParent->rhs();
/*
	if (isSgLabelRefExp(keyword)) {
	   SgLabel *label = isSgLabelRefExp(keyword)->label();
	   SgStatement *labstmt = label->statBody();
	   ASSERT(labstmt->variant() == FORMAT_STAT);
	   SgExpression *stmt_str = labstmt->expr(0); ASSERT(stmt_str);
	   char *str = stmt_str->thellnd->entry.string_val; ASSERT(str);
	   ASSERT(0);
	}
	else 
*/
	{
/*
           ASSERT(isSgKeywordValExp(keyword));
	   if (strcasecmp(isSgKeywordValExp(keyword)->value(),"*")!=0) ASSERT(0);
*/
   	   SgExpression *stmt_str = new SgExpression(STMT_STR);
   	   sprintf(fmt,"(%dA)",kindval);
   	   stmt_str->thellnd->entry.string_val = fmt;
   	   SgStatement *format = new SgStatement(FORMAT_STAT, NULL, NULL, stmt_str, NULL, NULL);
   	   SgLabel *label = new SgLabel(*format);
   	   format->setLabel(*label);
   	   print->insertStmtAfter(*format, *print->controlParent());
   	   SgExpression *lab = new SgValueExp(label->labelValue());
	   keyParent->setRhs(*lab);
	}
   }
   else {
	ASSERT(0);
/*
	SgExpression *fmt = new SgValueExp("fmt");
	SgExpression *spec = new SgExpression(SPEC_PAIR, fmt, lab, NULL);
	SgExpression *exprlist = new SgExpression(EXPR_LIST, spec, print->specList(),NULL);
	print->setSpecList(*exprlist);
*/
   }

}

void change_reference(SgInputOutputStmt * print, int counter)
{
  io_reference * iref= (io_reference *) print->attributeValue(counter, Io_Ref);

  SgArrayRefExp * array = (SgArrayRefExp *) iref->expression();  
  SgSymbol * arraysymb  = array->symbol();
  SgType * type = arraysymb->type();

  int storage = getArrayStorage(arraysymb);

#ifdef MEM_ALLOC
  SgSymbol * newsymb = print->getSymbolInCurrentScope(stackNameOfType(arraysymb->type()),"mb", NULL);
#else
  SgSymbol * newsymb = print->getSymbolInCurrentScope(mixstring, stackNameOfType(arraysymb->type()), NULL);
#endif

  SgArrayRefExp * newarray = new SgArrayRefExp(*newsymb);

  SgSymbol * basesym = print->getSymbolInCurrentScope(mixstring, "tbs", NULL,counter);
//  SgExpression * baseexp= new SgVarRefExp(basesym);
  SgExpression * baseexp = NULL;

    Impdo_header_def *ihdef = iref->ihdef;
    if (ihdef) {

    // since this is a new array, we can get memstride by simple computation;

    SgExpression * memstride = NULL;
    
    int numberOfSubscripts = array->numberOfSubscripts();
    int dimno; 
    int i;
    for (dimno = 0; dimno < numberOfSubscripts; dimno++) 
    {

      if (storage == COLUMN_MAJOR) {
	i = dimno;
      }
      else {
	i = numberOfSubscripts - dimno - 1;
      }

	//modified by zheng.gb  1998/2/6
      int dim = iref->indexSequenceOnDim(i);
        // means this dim is scalar ,memstride=memstride * 1 , no touch
      if (dim == -1) continue;

      ASSERT(ihdef);
      SgSymbol * indexsym = ihdef->indexSymbol(dim);
      SgExpression * newindex = new SgVarRefExp(indexsym);

      newindex = memstride * (*newindex);
      baseexp= baseexp+ (*newindex);

      //update memstride in the following;

      SgExpression * lb=ihdef->getIndexTriplet(dim, 0);
      if (lb) lb=lb->copyPtr();
      SgExpression * ub=ihdef->getIndexTriplet(dim, 1);
      if (ub) ub=ub->copyPtr();
      SgExpression * st=ihdef->getIndexTriplet(dim, 2);
      if (st) st=st->copyPtr();

	// by zheng.gb
      SgExpression *val1 = new SgValueExp(1);

      if (COMPACT) {
        memstride = memstride * (*ub - *lb);
	if (st) {
		memstride = &(*memstride / *st->copyPtr());
        }
        memstride = memstride + (*val1);
      }
      else
        memstride = memstride * ((*ub)-(*lb)+(*val1));

      memstride = calculateExp(memstride);
    }
  }

    // T_KIND like T_CHAR/T_STRING must generate implied-do
  int add_impdo = 0;
  SgType *baseType = type;
  if (type->hasBaseType()) baseType=baseType->baseType();
  SgKindType *kindtype = isSgKindType(baseType);
  if (kindtype) {
	int variant = kindtype->baseType()->variant();
	if (variant == T_CHAR || variant == T_STRING) {
		add_impdo = 1;
		if(print->numberOfAttributes(Io_Ref)>1) {
			printf("Sorry, not supported this kind of I/O.\n");
			ASSERT(0);
		}
	}
  }
  
  if ( add_impdo == 1)
  {
	SgExpression *kindval = isSgKindType(baseType)->kindVal();
	ASSERT(kindval);
	kindval = kindval->lhs();

	if (print->variant() == READ_STAT)
		add_format_for_read(print, kindval);

	SgExpression *kindval1 = &(*kindval - *new SgValueExp(1));
	kindval1 = calculateExp(kindval1);
	SgExpression *zero = new SgValueExp(0);
	SgExpression *rangeop = new SgExpression(RANGE_OP, zero, kindval1, NULL);
	SgExpression *ddot = new SgExpression(DDOT, rangeop, NULL, NULL);
	SgExpression *expr_list = new SgExpression(EXPR_LIST, newarray, NULL, NULL);
  	SgSymbol *index = print->getSymbolInCurrentScope(mixstring, "oci", NULL, array->id());
	SgExpression *impdo = new SgExpression(IMPLIED_DO, expr_list, ddot, index);
	if (baseexp) baseexp = &(*baseexp * *kindval);
	baseexp = baseexp + *new SgVarRefExp(index);
	baseexp= &(*new SgVarRefExp(basesym) + *baseexp);
  	newarray->addSubscript(*baseexp);
	newarray = (SgArrayRefExp *)impdo;
  }
  else {
	baseexp= baseexp + *new SgVarRefExp(basesym);
	newarray->addSubscript(*baseexp);
  }

  array->replace(*newarray);

}

void add_remap(SgInputOutputStmt * print, int counter)
{

  SgSymbol *dstsymb=print->getSymbolInCurrentScope(mixstring, "tdd", NULL, counter);
  SgSymbol *srcsymb=print->getSymbolInCurrentScope(mixstring, "sdd", NULL , counter);


  io_reference * iref = (io_reference *) print->attributeValue(counter, Io_Ref);
  if (iref->useNo() > 0) return;

  if (print->variant()==READ_STAT)
  {
	  // need to retrive data 
  	io_reference * iref = (io_reference *) print->attributeValue(counter, Io_Ref);
    	Impdo_header_def *ihdef = iref->ihdef;
	  // add optimization, if stride is 1, no remap needed.
	if ( ihdef != NULL )
	{
	  int retrieve = 0;
    	  for (int i = 0; i< ihdef->numberOfIndex(); i++) {
      		SgExpression * stride =ihdef->getIndexTriplet(i, 2);
		if ( stride == NULL) continue;
		if ( stride->isInteger() && stride->valueInteger() == 1) continue;
		retrieve = 1;
	  }
	  if (retrieve) {
  		SgStatement *funcall=make_remap(print,dstsymb,srcsymb);
  		print->insertStmtBefore(*funcall, *print->controlParent());
	  }
	}

  	SgStatement *funcall=make_remap(print,srcsymb,dstsymb);
  	print->insertStmtAfter(*funcall, *print->controlParent());
  }
  else {
  	SgStatement *funcall=make_remap(print,dstsymb,srcsymb);
  	print->insertStmtBefore(*funcall, *print->controlParent());
  }
}

void change_io_reference(SgInputOutputStmt * print, int counter) 
{

  io_reference * iref = (io_reference *) print->attributeValue(counter, Io_Ref);
  Impdo_header_def * ihdef = iref->ihdef;

  //printf("the io reference is %d , %s\n", iref->expression()->id(),iref->expression()->symbol()->identifier() );

  if ((iref->expression()->symbol()->numberOfAttributes(Align_Def)==0)
      &&(iref->expression()->symbol()->numberOfAttributes(Inherit_Def)==0)) {
          // local no explicit distributed array, do nothing;
    	if (iref->checkRegular()==1) {
      		create_section(print, counter);
      		create_array(print, counter);
      		add_remap(print, counter);
      		change_reference(print, counter);
    	}
    	else {
      		printf("change_io_reference:not finished yet!\n");
    	}
  }
  else {
    if (iref->checkRegular()==1) {
      create_section(print, counter);
      create_array(print, counter);
      add_remap(print, counter);
      change_reference(print, counter);
    }
    else {
      printf("change_io_reference:not finished yet!\n");
    }
  }
}

void change_var_reference(SgInputOutputStmt *print, int counter)
{
   SgExpression *sref=(SgExpression *)print->attributeValue(counter,IoScalar_Ref); 
   SgSymbol *symb = sref->symbol();

     // change pointer
   if (isSgArrayType(symb->type()) == NULL && is_pointer(symb))
   {
        change_variable_by_stack(print, sref);
   }

   if (print->variant()==READ_STAT)
   {
     int storage = getArrayStorage(symb);
     symb->addAttribute(NeedDad_Def, NULL,0);

     SgSymbol * tdd=print->getSymbolInCurrentScope(mixstring, "tdd", NULL, counter);
     SgSymbol * dad=print->getSymbolInCurrentScope(mixstring, "dad", symb->identifier());
     counter = counter + print->numberOfAttributes(Io_Ref);

    // pcrc_new_array_data
   {
     SgType * stype= symb->type();
     SgSymbol * grp=print->getSymbolInCurrentScope(mixstring, "grp", "io");
     SgExpression *grpExp = new SgVarRefExp(grp);
//     SgExpression *add = new SgVarRefExp(symb);
     SgExpression *add = sref->copyPtr();
     SgStatement *assign = make_new_array_data1(print, tdd, add, stype, storage, 
						0, grpExp);
     print->insertStmtBefore(*assign, *print->controlParent());
   }

   // delete dad;
   {
     SgStatement *funcall = make_delete_array(print , tdd);
     print->insertStmtAfter(*funcall, *print->controlParent());
   };

    // remap
    {
     SgStatement *funcall=make_remap(print,dad,tdd);
     print->insertStmtAfter(*funcall, *print->controlParent());
    }
  }
}

void change_impdo_header(SgInputOutputStmt * print)
{
//  if (print->numberOfAttributes(IHDER_Def)!=0) {
  for (int num=0; num < print->numberOfAttributes(IHDER_Def); num++)
  {
    Impdo_header_def * ihdef = (Impdo_header_def *)print->attributeValue(num, IHDER_Def);

    for (int i = 0; i< ihdef->numberOfIndex(); i++) {

      SgExpression * lb=ihdef->getIndexTriplet(i, 0);
      SgExpression * ub=ihdef->getIndexTriplet(i, 1);
      SgExpression * stride =ihdef->getIndexTriplet(i, 2);

      SgExpression * newlb = new SgValueExp(0);

      SgExpression * newub ;
      
      // we do not change stride temporarily, in case u-l can not divide s;
      
      newub = &((* ub->copyPtr())-(*lb->copyPtr()));
      if (COMPACT) {
	if (stride)
		newub = &( *newub / *stride->copyPtr());
      }
      newub = calculateExp(newub);
      analyse_expression(print, newub);

      lb->replace(*newlb);
      ub->replace(*newub);
      if (COMPACT)
	if (stride)
	        stride->replace(*new SgValueExp(1));

    }    
  };

}

void change_datatransfer(SgInputOutputStmt * print)
{
  int i;
  int ioref_dim_num[MAXNUM];

  for (i=0; i<print->numberOfAttributes(Io_Ref); i++) {

     // add by slx 98/3/8
     // in order to record dim_num in a io_reference
    io_reference *iref=(io_reference *)print->attributeValue(i,Io_Ref); 
    ioref_dim_num[i]=((SgArrayRefExp *)iref->expression())->numberOfSubscripts();

    change_io_reference(print, i);
  };

    // we also must deal with scalar variable in io list.
  for (i=0; i<print->numberOfAttributes(IoScalar_Ref); i++) {
	SgExpression *sref=(SgExpression *)print->attributeValue(i,IoScalar_Ref); 
	change_var_reference(print, i);
  };

  change_impdo_header(print);

  SgSymbol * grp = print->getSymbolInCurrentScope(mixstring, "grp", "io");
  SgExpression * grpexp = new SgVarRefExp(grp);

  SgExpression *onexp = make_on(print, grpexp);

  //add by slx 98/4/2
  if((ioMode==IO_C)  && (isIooc(print)==0) && (print->variant()!=PRINT_STAT) &&
     (print->numberOfAttributes(Io_Ref)==1) &&
     (print->numberOfAttributes(IHDER_Def)==1) &&
     is_format_io(print) == 0  )      
     change_datatransfer2C(print,onexp);  //IO_C && IN_CORE
  else
  {
    SgIfStmt * ifstmt = new SgIfStmt(*onexp, print->copy());

    print->insertStmtBefore(*ifstmt, *print->controlParent());

      // add by slx  98/3/4
    trans_iooc(print,ifstmt,ioref_dim_num);
  }

}


//
//
void trans_datatransfer(SgStatement * s)
{
  SgInputOutputStmt * print = (SgInputOutputStmt *)s;

  // add_grp0(print);

  change_datatransfer(print);
}


//----------------------------

//
//
void trans_datacontrol(SgStatement * s)
{

  SgIOControlStmt * open = (SgIOControlStmt *)s;

  SgSymbol * grp = open->getSymbolInCurrentScope(mixstring, "grp", "io");
  SgExpression * grpexp = new SgVarRefExp(grp);

  SgExpression *onexp = make_on(open, grpexp);

  // add slx 98/3/23
  if(ioMode==IO_C)
  {
    ASSERT(open->controlSpecList());
    SgExpression *controlSpeclist=open->controlSpecList()->copyPtr();
    switch(s->variant())
    {
      case OPEN_STAT:
          {
           SgExpression *expr;
           SgExpression *unit;
           SgExpression *fileName;
            // 'new'(1) or 'old'(0) or 'unknown'(default=-1)
            SgExpression *status=new SgValueExp(-1);
           // 'direct'(1)  or 'sequential'(default=0) 
           SgExpression *access=new SgValueExp(0);
           // 'unformatted'(1) or 'formatted'(default=0)
           SgExpression *form=new SgValueExp(0); 
           // record length (default=-1)
           SgExpression *recl=new SgValueExp(-1); 
           for(expr=controlSpeclist; expr; expr=expr->rhs())
           {
             SgExpression *keyParent=expr->lhs();
             SgKeywordValExp *keyword=isSgKeywordValExp(keyParent->lhs());
             if(keyword != NULL )
              {
               if(strcasecmp(keyword->value(),"unit")==0)
	       {
                   unit=keyParent->rhs()->copyPtr();
		   analyse_expression(s, unit);
	       }
               if(strcasecmp(keyword->value(),"file")==0)
	       {
                   fileName=keyParent->rhs()->copyPtr();
		   analyse_expression(s, fileName);
	       }
               if(strcasecmp(keyword->value(),"status")==0)
                {
                   SgExpression *statusExp=keyParent->rhs();
                   SgValueExp *statusStr=isSgValueExp(statusExp);   
                   if(statusStr!=NULL)
                   {
                     if(strncasecmp(statusStr->stringValue()+1,"new",3)==0)
                       status=new SgValueExp(1);
                     if(strncasecmp(statusStr->stringValue()+1,"old",3)==0)
                       status=new SgValueExp(0);
                   }
                }
               if(strcasecmp(keyword->value(),"access")==0)
                {
                   SgExpression *accExp=keyParent->rhs();
                   SgValueExp *accStr=isSgValueExp(accExp);   
                   if(accStr!=NULL)
                     if(strncasecmp(accStr->stringValue()+1,"direct",6)==0)
                       access=new SgValueExp(1);
                }
               if(strcasecmp(keyword->value(),"form")==0)
                {
                   SgExpression *formExp=keyParent->rhs();
                   SgValueExp *formStr=isSgValueExp(formExp);   
                   if(formStr!=NULL)
                     if(strncasecmp(formStr->stringValue()+1,"unformatted",11)==0)
                       form=new SgValueExp(1);
                }
               if(strcasecmp(keyword->value(),"recl")==0)
                   recl=keyParent->rhs()->copyPtr();
              }
           }
           if(((SgValueExp* )form)->intValue()==0)
           {
             SgIfStmt * ifstmt = new SgIfStmt(*onexp, open->copy());
             open->insertStmtBefore(*ifstmt, *open->controlParent());
           }
           else {
           SgSymbol *symb=s->getSymbolInCurrentScope(mixstring,"open",NULL);
           SgSymbol *lenSymb=s->getSymbolInCurrentScope("len");
           SgCallStmt *openStmt=new SgCallStmt(*symb);
           openStmt->addArg(*unit->copyPtr());
           ASSERT(fileName);
           openStmt->addArg(*fileName->copyPtr());
           SgFunctionCallExp *len=new SgFunctionCallExp(*lenSymb);
           len->addArg(*fileName->copyPtr());
           openStmt->addArg(*len->copyPtr());
           openStmt->addArg(*status->copyPtr());
           openStmt->addArg(*access->copyPtr());
           openStmt->addArg(*form->copyPtr());
           openStmt->addArg(*recl->copyPtr());
           
           SgIfStmt * ifstmt = new SgIfStmt(*onexp, openStmt->copy());
           open->insertStmtBefore(*ifstmt, *open->controlParent());
           }
           break;
          }
      case CLOSE_STAT:
          {
           SgExpression *expr;
           for(expr=controlSpeclist; expr; expr=expr->rhs())
           {
             SgExpression *keyParent=expr->lhs();
             SgKeywordValExp *keyword=isSgKeywordValExp(keyParent->lhs());
             if(keyword != NULL )
               if(strcasecmp(keyword->value(),"unit")==0)
                 {
                  SgSymbol *symb=s->getSymbolInCurrentScope(mixstring,"close",NULL);
                  SgFunctionCallExp *close=new SgFunctionCallExp(*symb);
                  close->addArg(*keyParent->rhs()->copyPtr());
                  SgIfStmt * ifstmt = new SgIfStmt(SgNotOp(*close), open->copy());
                  SgIfStmt * newifstmt = new SgIfStmt(*onexp,ifstmt->copy());
                  open->insertStmtBefore(*newifstmt, *open->controlParent());
                  break;
                 }
           }
           break;
          }
    }     //switch
  }               // IO_C
  else   	// IO_FORTRAN
  {    
    SgIfStmt * ifstmt = new SgIfStmt(*onexp, open->copy());
    open->insertStmtBefore(*ifstmt, *open->controlParent());
  }

}

/****************************************************************************
	support !HPF$  FILEMAP ( a > "data")
		!HPF$  FILEMAP ( a < "data")
		!HPF$  FILEMAP ( a = "data")
****************************************************************************/

void analyse_filemap(SgStatement * s)
{
    SgExpression *op = s->expr(0);
    SgSymbol *arraysymb = op->lhs()->symbol();
    if (op->variant() == EQ_OP) 
	ASSERT(is_out_of_core(arraysymb));
}

// the storage mode of file is same as the files.
void trans_filemap(SgStatement * s)
{
    SgExpression *op = s->expr(0);
    SgExpression *expr = op->lhs();
    SgSymbol *arraysymb = op->lhs()->symbol();
    SgArrayType * stype= isSgArrayType(arraysymb->type()); ASSERT(stype);
    SgExpression *fileExp = op->rhs();
    SgExpression *major = s->expr(1);

    analyse_expression(s, fileExp);

    SgSymbol * dad ;
    dad = s->getSymbolInCurrentScope(mixstring, "dad", arraysymb->identifier());
    if ( isSgArrayRefExp(expr) )
    {
	SgArrayRefExp *array = isSgArrayRefExp(expr); 
	SgSymbol *sdd = s->getSymbolInCurrentScope(mixstring, "sdd", arraysymb->identifier());
	SgStatement *sect = make_new_array_section(s, sdd, stype->dimension(), dad);
    	s->insertStmtBefore(*sect, *s->controlParent());
    	define_array_from_arrayref(s, array, sdd);
	  // delete sdd
	SgStatement *delete_stmt = make_delete_array(s , sdd);
	s->insertStmtAfter(*delete_stmt, *s->controlParent());

	dad = sdd;
    }
    
    if (op->variant() == EQ_OP) {
    	SgStatement *filemap = make_oc_filemap(s, dad, fileExp, IN_CORE_SIZE);
    	s->insertStmtBefore(*filemap, *s->controlParent());
    }
    else {

     // create TDD? 
    SgSymbol * tdd = s->getSymbolInCurrentScope(mixstring, "tdd", NULL, 0);

      // the storage mode of file is same as the files.
    int storage = getArrayStorage(arraysymb);
    if (major) 	{
	ASSERT(isSgValueExp(major));
	char *major_str = isSgValueExp(major)->stringValue();
	if (strcasecmp(major_str,"\"row\"") == 0) storage = ROW_MAJOR;
	if (strcasecmp(major_str,"\"column\"") == 0) storage = COLUMN_MAJOR;
    }

    int dim = stype->dimension();

    // pcrc_new_array_data
    {
    SgSymbol * grp=s->getSymbolInCurrentScope(mixstring, "grp", "io");
    SgExpression *grpExp = new SgVarRefExp(grp);
    SgStatement *assign = make_new_array_data(s, tdd, stype, storage, dim, grpExp);
    s->insertStmtBefore(*assign, *s->controlParent());
    }

    {
    int dimcounter = storage==COLUMN_MAJOR?0:dim+1;
    int d, i;
    for (d=0; d<dim; d++) {
	// set_array_collapse
      if (storage == COLUMN_MAJOR)
    	i = d;
      else 
	i = dim - d -1;
      if (storage == COLUMN_MAJOR) dimcounter++;
      else dimcounter--;

      SgExpression *start = get_lbound_from_arrayexp(expr,dimcounter-1);
      analyse_expression(s, start);
      SgExpression *end = get_ubound_from_arrayexp(expr,dimcounter-1);
      analyse_expression(s, end);

      SgStatement *func = make_set_array_collapse(s, tdd, dimcounter, 
						start, end);
      s->insertStmtBefore(*func, *s->controlParent());
    }
    }

    SgStatement *filemap = make_oc_filemap(s, tdd, fileExp, IN_CORE_SIZE);
    s->insertStmtBefore(*filemap, *s->controlParent());

    if(ioMode == IO_C)
	if (storage != storageMode)
  	{
	   SgStatement *stmt;
	   stmt = make_set_global_major(s, storage);
	   s->insertStmtBefore(*stmt, *s->controlParent());
	   stmt = make_set_global_major(s, storageMode);
	   s->insertStmtAfter(*stmt, *s->controlParent());
	}

    switch (op->variant())
    {
    case LT_OP: {
	SgStatement *remap = make_remap(s, dad, tdd);
    	s->insertStmtBefore(*remap, *s->controlParent());
	break;
      }
    case GT_OP:
	SgStatement *remap = make_remap(s, tdd, dad);
    	s->insertStmtBefore(*remap, *s->controlParent());
	break;
    }

    // delete dad;
    {
    SgStatement *funcall = make_delete_array(s , tdd);
    s->insertStmtAfter(*funcall, *s->controlParent());
    };

    }  // if EQ_OP
  
    s->deleteStmt();
}


